
/**********************Document Ready****************************************/

$(document).ready(function(){
    
    /***********************real time display********************************/
    
    var days = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'];
    
    let regionNames = new Intl.DisplayNames(['en'], {type: 'region'});
    
    const convertTime12to24 = time12h => {const [time, modifier] = time12h.split(" ");let [hours, minutes] = time.split(":");if (hours === "12") {hours = "00";}if (modifier === "PM") {hours = parseInt(hours, 10) + 12;}return `${hours}:${minutes}`;};
    
    function refreshTime() {
      const timeDisplay = document.getElementById("realtime");
      const dateString = new Date().toLocaleTimeString();
      const formattedString = dateString.replace(", ", " - ");
      timeDisplay.textContent = formattedString;
    }   
    setInterval(refreshTime, 1000);
    
    function refreshukTime() {
        const timeDisplay = document.getElementById("ukTimeZone");
        var d = new Date(); /* midnight in China on April 13th */
        const dateString = d.toLocaleTimeString('en-US', { timeZone: 'Europe/London' });
        const formattedString = dateString.replace(", ", " - ");
        timeDisplay.textContent = formattedString;
    }
    setInterval(refreshukTime, 1000);
    
    function refreshusTime() {
        const timeDisplay = document.getElementById("usaTimeZone");
        var d = new Date(); /* midnight in China on April 13th */
        const dateString = d.toLocaleTimeString('en-US', { timeZone: 'America/New_York' });
        const formattedString = dateString.replace(", ", " - ");
        timeDisplay.textContent = formattedString;
    }
    setInterval(refreshusTime, 1000);  
    
    function refreshghTime() {
        const timeDisplay = document.getElementById("ghTimeZone");
        var d = new Date(); /* midnight in China on April 13th */
        const dateString = d.toLocaleTimeString('en-US', { timeZone: 'Africa/Accra' });
        const formattedString = dateString.replace(", ", " - ");
        timeDisplay.textContent = formattedString;
    }
    setInterval(refreshghTime, 1000);
    
    function refreshinTime() {
        const timeDisplay = document.getElementById("inTimeZone");
        var d = new Date(); /* midnight in China on April 13th */
        const dateString = d.toLocaleTimeString('en-US', { timeZone: 'Asia/Kolkata' });
        const formattedString = dateString.replace(", ", " - ");
        timeDisplay.textContent = formattedString;
    }
    setInterval(refreshinTime, 1000);
    
    const timezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
    
    
    /**********required***************************************/

    function getTimeOffset(country = 'Asia/calcutta', summerTime = false) {
        let date = new Date(new Date().getFullYear(), summerTime ? 6 : 11, 1);
        let wordTime = new Date(date.toISOString().substr(0, 19)).getTime();
        let localTime = new Date(date.toLocaleString('en', { timeZone: country })).getTime();
    
        return (wordTime - localTime) / 1000 / 60;
    }
        
    /*****************************Display Teacher*************************/
    
    getAllCourse();
    function getAllCourse(){
        $type = "Course";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{"type":$type},
            success:function(data){
                $('#coursecount').text(data);
            },
            error:function(data){
            }
        });
    }
    
    /*****************************Display upcoming Student *****************/
    
    getUpcomingClass();
    function getUpcomingClass(){
        $type = "upcomingclass";
        $('#ucStart').prop("disabled",true);
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{"type":$type},
            success:function(data){
                $.each(data,function(i,row){
                    $date = getdateformat(row[6]);
                    var date = new Date(row[6]);
                    var day = date.getDay();
                    var datecount = date.getDate();
                    var month = date.getMonth() + 1;
                    var year = date.getFullYear();
                    if(row[30].indexOf('zoom') != -1){
                        $details = row[30];
                    }else{
                        $details = "startclass?/"+row[0]+"/"+row[30];
                    }
                    $country = regionNames.of(row[18]);
                    $datetocheckst = gettime(month,datecount,year,row[7]);
                    $datetochecked = gettime(month,datecount,year,row[8]);
                    const timezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
                    const localstartdatetime = getlocaltime($datetocheckst,timezone).split(", ");
                    const localenddatetime = getlocaltime($datetochecked,timezone).split(", ");
                    const studentstartdatetime = getlocaltime($datetocheckst,row[28]).split(", ");
                    const studentenddatetime = getlocaltime($datetochecked,row[28]).split(", ");
                    $localdaydate = localstartdatetime[0]+", "+localstartdatetime[2]+" - "+localenddatetime[2];
                    $studentdaydate = studentstartdatetime[0]+", "+studentstartdatetime[2]+" - "+studentenddatetime[2];
                    var localdate = new Date(localstartdatetime);
                    var timenow = new Date();
                    var timematch = localdate;
                    timematch.setMinutes(timematch.getMinutes() - 10);
                    if( timenow >= timematch){
                        $('#ucStart').prop("disabled",false);
                    }
                    $localdatetime = localdate.getDate()+"-"+(localdate.getMonth()+1)+"-"+localdate.getFullYear();
                    $('#ucDate').text($localdatetime);
                    $('#ucTime').text($localdaydate);
                    $('#ucCourse').text(row[5]);
                    $('#ucCountry').text($country);
                    $('#ucSession').text(row[26]);
                    $('#classtype').text(row[32]);
                    $('#ucaTime').text($studentdaydate);
                    $('#ucStartlink').attr('href',$details);
                    $type = "getstudentprofile";
                    getprofilename(row[4],$type,i);
                });
            },
            error:function(data){
                $('#upcomingclassdetails').empty();
                $('#upcomingclassdetails').append(
                       '<div class="mb-0"><h2 class="card-heading text-center mb-0">Upcoming Class</h2></div><span class="question-tag-new" id="classtype">No Class</span><div class="tab-content best_teacher_tab_content mb-4"><div class="d-flex flex-column text-center p-5 m-5"><div class="custom-radio mr-5"><h6><span class="pr-2 pl-2">No Upcoming Class</span></h6></div></div></div>'+
                        '<div class="tab-content best_teacher_tab_content"><div class="d-flex flex-column flex-row p-2 m-2"><button class="btn main-btn btn-paid" id="ucSchedule">Schedule class</button></div></div>'
                );
            }
        });
    }

    function getdateformat(orginaldate) { 
        var date = new Date(orginaldate);
        var day = date.getDate();
        var month = date.getMonth() + 1;
        var year = date.getFullYear();
        if (day < 10) {
            day = "0" + day;
        }
        if (month < 10) {
            month = "0" + month;
        }
        var formateddate =  day + "-" + month + "-" + year; 
        return formateddate;
    }
    
    function gettime(month,datecount,year,time){
        $datetocheck = month+"-"+datecount+"-"+year+" "+time+" UTC";
        return $datetocheck;
    }
    
    function getlocaltime($datetocheckst,timezone){
        $datetime = new Date($datetocheckst).toLocaleString('en-US', { timeZone: timezone, weekday: 'long', year: 'numeric', month: 'numeric', day: 'numeric',hour12:true,hour:'numeric',minute:'numeric'});
        return $datetime;
    }
    
    /*****************************Schedule class*************************/
    
    $(document).on('click','#ucSchedule',function(){
        $(location).prop('href', 'teachertimetable');
    });
    
    
    /*****************************Display Student*************************/
    
    getAllStudent();
    function getAllStudent(){
        $type = "Student";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{"type":$type},
            success:function(data){
                $('#studentcount').text(data);
            },
            error:function(data){
            }
        });
    }
    
    /*****************************Display Prospect*************************/
    
    getAllProspect();
    function getAllProspect(){
        $yeard = $('.sSignups').text();
        $type = "Prospect";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $type,
                "yeard": $yeard
            },
            success:function(data){
                $('#prospectcount').text(data);
            },
            error:function(data){
            }
        });
    }
    
    /*****************************getReferralDetails************************/
    
    getReferralDetails();
    function getReferralDetails(){
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": "get referral link",
            },
            success:function(data){
                $('.referrallink').text(data.referrallink);
            },
            error:function(data){
            }
        });
    }
    
    function copyToClipboard(element) {
          var $temp = $("<input>");
          $("body").append($temp);
          $temp.val($(element).text()).select();
          document.execCommand("copy");
          $temp.remove();
    }
    
    $('.getcopyiedtext').on("click",function(){
        copyToClipboard('.referrallink');
    });
    
    /*****************************Display Prospect*************************/
    
    
    function getprofilename($profileid,$type,i){
        //$type = "getprofilenamefromid";
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $type,
                "profileid": $profileid
            },
            success:function(data){
                $profilepath = '../admin/assets/uploads/'+data['oname']+"/"+data['profilepic'];
                const getfilename = checkstatus($profilepath);
                if(getfilename == "200" && data['profilepic'] != ""){
                   $profilepath = '../admin/assets/uploads/'+data['oname']+"/"+data['profilepic'];
                }else{
                   if(data['gender'] == "M"){
                       $profilepath = '../admin/assets/img/adminAllNew/boyS.jpeg';
                   }else{
                       $profilepath = '../admin/assets/img/adminAllNew/girlS.jpeg';
                   }
                   
                }
                if($type == "studentST"){
                    $id = $profileid.replace(" ","--")+"-"+i;
                    $('#'+$id).children(".studentname").text(data['fname']+" "+data['lname']);
                    $('#'+$id).children(".studentUP").children('img').prop('src',$profilepath);
                }
                if($type == "getstudentprofile"){
                    $classprofile = $profileid.replaceAll(" ","--");
                    $('#ucStudent').text(data['fname']+" "+data['lname']);
                    $('#ucStudent').attr("class",$classprofile);
                }
            },
            error:function(data){
            }
        });
    }
    
    /*****************************Display Performance******************/
    $type1 = "getPerformance";
    getAllPerformance($type1);
    $type2 = "getDemoRecord";
    getAllPerformance($type2);
    $type3 = "getPaidRecord";
    getAllPerformance($type3);
    $type4 = "getmonthlyPaidRecord";
    getAllPerformance($type4);
    $type5 = "getmonthlyTrialRecord";
    getAllPerformance($type5);
    $type6 = "getmonthlyTrialCancellation";
    getAllPerformance($type6);
    $type7 = "getmonthlyPaidCancellation";
    getAllPerformance($type7);
    $type8 = "todayClass";
    getAllPerformance($type8);
    function getAllPerformance($type){
        const timezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $type,
                "teachertz": timezone
            },
            success:function(data){
                if($type == "getPerformance"){
                    $sum = 0;
                    $.each(data,function(i,row){
                        $sum = $sum + parseInt(row[0]);
                    });
                    $average = Math.round($sum/data.length);
                    $('#overallCR').text($average);
                }
                if($type == "getDemoRecord"){
                    $sum = 0;
                    $totalrow = data.length;
                    $.each(data,function(i,row){
                        if(row[0] == "Enrollment Successful"){
                            $sum = $sum + row.length;
                        }
                    });
                    $assignedstudent = $('#studentcount').text();
                    $enrollmentpercent = Math.round(($sum/$totalrow)*100);
                    $('#totaldemo').text($totalrow);
                    $('#totalenrolled').text($sum);
                    $('#totalassigned').text($assignedstudent);
                    $('#enrollpercent').text($enrollmentpercent+"%");
                }
                if($type == "getPaidRecord"){
                    $('#totalpaid').text(data);
                }
                if($type == "getmonthlyPaidRecord"){
                    $sum = 0;
                    $.each(data,function(i,row){
                        $sum = $sum + parseInt(row[0]);
                    });
                    $average = Math.round($sum/data.length);
                    $('#mpr').text($average);
                    $('#pcr').text(data.length);
                }
                if($type == "getmonthlyTrialRecord"){
                    $sum = 0;
                    $.each(data,function(i,row){
                        $sum = $sum + parseInt(row[0]);
                    });
                    $average = Math.round($sum/data.length);
                    $('#mtr').text($average);
                    $('#dcr').text(data.length);
                }
                if($type == "getmonthlyTrialCancellation"){
                    $('#mtcan').text(data+"/3");
                }
                if($type == "getmonthlyPaidCancellation"){
                    $('#mpcan').text(data+"/3");
                }
                if($type == "todayClass"){
                    $.each(data,function(i,row){
                        var date = new Date(row[6]);
                        var day = date.getDay();
                        var datecount = date.getDate();
                        var month = date.getMonth() + 1;
                        var year = date.getFullYear();
                        $datetocheckst = gettime(month,datecount,year,row[7]);
                        $datetochecked = gettime(month,datecount,year,row[8]);
                        const timezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
                        const localstartdatetime = getlocaltime($datetocheckst,timezone).split(", ");
                        const localenddatetime = getlocaltime($datetochecked,timezone).split(", ");
                        const studentstartdatetime = getlocaltime($datetocheckst,row[28]).split(", ");
                        const studentenddatetime = getlocaltime($datetochecked,row[28]).split(", ");
                        $localdaydate = localstartdatetime[2]+" - "+localenddatetime[2];
                        var localdate = new Date(localstartdatetime);
                        $localdatetime = localdate.getDate()+"-"+(localdate.getMonth()+1)+"-"+localdate.getFullYear();
                        $rowid = row[4].replace(" ","--")+"-"+i;
                        $datetimenow = new Date();
                        var datenow = $datetimenow.getDate()+"-"+($datetimenow.getMonth() + 1)+"-"+$datetimenow.getFullYear();
                        let minutes = $datetimenow.getMinutes();
                        minutes = minutes <= 9 ? '0' + minutes : minutes;
                        var timenow = $datetimenow.getHours()+":"+minutes;
                        const pattern12hrs = new Date('1970-01-01T' + timenow + 'Z').toLocaleTimeString('en-US',{timeZone:'UTC',hour12:true,hour:'numeric',minute:'numeric'});
                        $timetotest = new Date(localstartdatetime[1]+" "+localstartdatetime[2]);
                        $timetotest.setHours($timetotest.getHours() + 1);
                        // console.log($timetotest);
                        // console.log($datetimenow);
                        // if($datetimenow >= $localdatetime && pattern12hrs>localstartdatetime[2]){
                        if($datetimenow >= $timetotest){
                            if(row[16] == ""){
                                $status = "Slot Expired";
                            }else{
                                $status = row[16];
                            }
                        }else{
                            if(row[16] == ""){
                                $status = "Upcoming";
                            }else{
                                $status = row[16];
                            }
                        }
                        $(".allBookingaday").append(
                            '<tr class="rowspan-tr" id="'+$rowid+'">'+
                                '<td class="studentUP"><img src="" alt="image"></td>'+
                                '<td class="studentname"></td>'+
                                '<td>'+row[5]+'</td>'+
                                '<td>'+$localdaydate+'</td>'+
                                '<td>'+row[32]+'</td>'+
                                '<td>'+$status+'</td>'+
                            '</tr>'
                        );
                        $type = "studentST";
                        getprofilename(row[4],$type,i);
                    });
                }
            },
            error:function(data){
                if($type == "todayClass"){
                    $(".allBookingaday").empty();
                    $(".allBookingaday").append(
                        '<tr>'+
                            '<td style="white-space: nowrap;"><p class="pb-0 mb-0">No class scheduled!</p></td>'+
                        '</tr>'
                    );
                }
            }
        });
    }
    
    
    /*****************************Go to Event*************************/
    
    $('#addeventd').on("click",function(){
        $(location).prop('href', 'upcomingevents');
    });
    
    /*****************************Prospect Click*************************/
    
    $('.sendquery').on("click",function(){
        $('#complainQ').css('border', 'none');
        $('#queryQ').css('border', 'none');
        $query = $('#queryQ').val();
        $querytext = $('#queryQ').text();
        $type = "sendQuery";
        $('.msgC').text('');
        if($querytext === ""){
            $('.msgC').text("Please mention your query before sending!!");
            $('.msgC').css('color', 'red');
            $('.msgC').css('font-size', '10px');
            $('#queryQ').css('border', '1px solid red'); 
        }else{
            sendmail($type,$query);
        }
    });
    
    $('.sendcomplain').on("click",function(){
        $('#complainQ').css('border', 'none');
        $('#queryQ').css('border', 'none');
        $complain = $('#complainQ').val();
        $type = "sendComplain";
        $('.msgC').text('');
        if($complain == ""){
            $('.msgC').text("Please mention your complain before sending!!");
            $('.msgC').css('color', 'red');
            $('.msgC').css('font-size', '10px'); 
            $('#complainQ').css('border', '1px solid red'); 
        }else{
            sendmail($type,$complain);
        }
    });
    
    function sendmail($type,$msg){
        $.ajax({
            url: "assets/php/dashboarddetails.php",
            method:"POST",
            dataType:"json",
            data:{
                "type": $type,
                "QCmsg":$msg
            },
            success:function(data){
                $('.msgC').text(data);
                $('.msgC').css('color', 'green');
                $('.msgC').css('font-size', '10px');
                $('#complainQ').val('');
                $('#queryQ').val('');
            },
            error:function(data){
            }
        });
    }
    
    /*****************************file path*************************/
    
    function checkstatus(path){
        var http = new XMLHttpRequest();
        http.open('HEAD', path, false);
        http.send();
        return http.status;
    }
    
    /*****************************Prospect Click*************************/
    
    $('#allprospects').on("click",function(){
        $(location).prop('href', 'viewprospect');
    });
    
    /*****************************Student Click*************************/
    
    $('#allstudents').on("click",function(){
        $(location).prop('href', 'viewstudent');
    });
    
    /*****************************Course Click*************************/
    
    $('#allcourses').on("click",function(){
        $(location).prop('href', 'allcourses');
    });
    
    /*****************************report Click*************************/
    
    $('#reports').on("click",function(){
        $(location).prop('href', 'progressreport');
    });
                                             
});